# zupper

A Zig version manager, written in zig.

WARNING: zupper is alpha software! Expect bugs!

## features

- managing multiple zig installations
  - installing zig
  - switching zig installations
  - removing installations
  - automatic updates
- fancy CLI
- concurrent downloading and unpacking
- multi-platform support (actually, not sure about windows xD)
- tiny binary (211 KB)
- few native dependencies
- written in zig

## building

### Linux

Zupper requires `libarchive` to be installed.
libarchive is used to unpack the compiler toolchain.
This dependency will probably be swapped out for zig a version at some point once a suitable library pops up.

1. Install the dependencies.

You probably already have them installed, but just to make sure, here are the commands to install them.

Arch:

```bash
pacman -S --needed \
    libarchive
```

Debian:

```bash
apt install \
    libarchive-dev
```

2. Install the zig toolchain

Zupper requires the development version of Zig (0.12.0 at the time of writing). Make sure you install one of the latest versions of Zig.

3. Build it!

```bash
zig build -Doptimize=ReleaseFast -p ~/.local
```

### macOS

I'll be honest here, I got no idea.

You should be able to do it in a similar fashion to Linux.

### windows

It might work if you can get the dependencies working. Maybe, I'll add static linking some day.

As for now, good luck lol.
